<html>
<head>
<title>OgreShaderExTextureAtlasSampler.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_f1fa7196649e3987904dbdb4948bc856.html">Components</a>      </li>
      <li class="navelem"><a class="el" href="dir_1ff0a99c786b1c34b8d04ba7e7285590.html">RTShaderSystem</a>      </li>
      <li class="navelem"><a class="el" href="dir_167378df2bdccc9b313fc91c17987f1d.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreShaderExTextureAtlasSampler.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreShaderExTextureAtlasSampler_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00009"></a>00009 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00010"></a>00010 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00011"></a>00011 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00012"></a>00012 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00013"></a>00013 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00016"></a>00016 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00017"></a>00017 <span class="comment"></span>
<a name="l00018"></a>00018 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00019"></a>00019 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00020"></a>00020 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00021"></a>00021 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00022"></a>00022 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00023"></a>00023 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00024"></a>00024 <span class="comment">THE SOFTWARE.</span>
<a name="l00025"></a>00025 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00026"></a>00026 <span class="comment">*/</span>
<a name="l00027"></a>00027 <span class="preprocessor">#ifndef _ShaderSGXAtlasTexture_</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span><span class="preprocessor">#define _ShaderSGXAtlasTexture_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderPrerequisites_8h.html">OgreShaderPrerequisites.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#ifdef RTSHADER_SYSTEM_BUILD_EXT_SHADERS</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="OgreShaderSubRenderState_8h.html">OgreShaderSubRenderState.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderParameter_8h.html">OgreShaderParameter.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="preprocessor">#define TAS_MAX_TEXTURES 4</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span><span class="keyword">namespace </span>Ogre {
<a name="l00037"></a>00037 <span class="keyword">namespace </span>RTShader {
<a name="l00038"></a>00038 
<a name="l00045"></a>00045 <span class="keyword">struct </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> TextureAtlasRecord
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047     TextureAtlasRecord(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp; texOriginalName, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp; texAtlasName, 
<a name="l00048"></a>00048                        <span class="keyword">const</span> <span class="keywordtype">float</span> texPosU, <span class="keyword">const</span> <span class="keywordtype">float</span> texPosV, <span class="keyword">const</span> <span class="keywordtype">float</span> texWidth, <span class="keyword">const</span> <span class="keywordtype">float</span> texHeight,
<a name="l00049"></a>00049                        <span class="keyword">const</span> <span class="keywordtype">size_t</span> texIndexInAtlas) :
<a name="l00050"></a>00050                   posU(texPosU)
<a name="l00051"></a>00051                 , posV(texPosV)
<a name="l00052"></a>00052                 , width(texWidth)
<a name="l00053"></a>00053                 , height(texHeight)
<a name="l00054"></a>00054                 , originalTextureName(texOriginalName)
<a name="l00055"></a>00055                 , atlasTextureName(texAtlasName)
<a name="l00056"></a>00056                 , indexInAtlas(texIndexInAtlas)
<a name="l00057"></a>00057     { }
<a name="l00058"></a>00058 
<a name="l00059"></a>00059     <span class="keywordtype">float</span> posU;
<a name="l00060"></a>00060     <span class="keywordtype">float</span> posV;
<a name="l00061"></a>00061     <span class="keywordtype">float</span> width;
<a name="l00062"></a>00062     <span class="keywordtype">float</span> height;
<a name="l00063"></a>00063     <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> originalTextureName;
<a name="l00064"></a>00064     <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> atlasTextureName;
<a name="l00065"></a>00065     <span class="keywordtype">size_t</span> indexInAtlas;
<a name="l00066"></a>00066 };
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 <span class="keyword">typedef</span> vector&lt;TextureAtlasRecord&gt;::type TextureAtlasTable;
<a name="l00069"></a>00069 <span class="keyword">typedef</span> SharedPtr&lt;TextureAtlasTable&gt; TextureAtlasTablePtr;
<a name="l00070"></a>00070 <span class="keyword">typedef</span> map&lt;String, TextureAtlasTablePtr&gt;::type TextureAtlasMap;
<a name="l00071"></a>00071 
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 
<a name="l00130"></a>00130 <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> TextureAtlasSampler : <span class="keyword">public</span> SubRenderState
<a name="l00131"></a>00131 {
<a name="l00132"></a>00132 <span class="keyword">public</span>:
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 <span class="comment">// Interface.</span>
<a name="l00135"></a>00135 <span class="keyword">public</span>:
<a name="l00136"></a>00136 
<a name="l00138"></a>00138     TextureAtlasSampler();
<a name="l00139"></a>00139 
<a name="l00143"></a>00143     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getType() <span class="keyword">const</span>;
<a name="l00144"></a>00144 
<a name="l00148"></a>00148     <span class="keyword">virtual</span> <span class="keywordtype">int</span> getExecutionOrder() <span class="keyword">const</span>;
<a name="l00149"></a>00149 
<a name="l00153"></a>00153     <span class="keyword">virtual</span> <span class="keywordtype">void</span> copyFrom(<span class="keyword">const</span> SubRenderState&amp; rhs);
<a name="l00154"></a>00154 
<a name="l00158"></a>00158     <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateGpuProgramsParams(Renderable* rend, Pass* pass,  <span class="keyword">const</span> AutoParamDataSource* source,  <span class="keyword">const</span> <a class="code" href="group__General.html#gaab30ef14aae93306a6044cb38d835f0c">LightList</a>* pLightList);
<a name="l00159"></a>00159 
<a name="l00163"></a>00163     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> preAddToRenderState(<span class="keyword">const</span> RenderState* renderState, Pass* srcPass, Pass* dstPass);
<a name="l00164"></a>00164 
<a name="l00165"></a>00165     <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> Type;
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 <span class="comment">// Protected methods</span>
<a name="l00168"></a>00168 <span class="keyword">protected</span>:  
<a name="l00169"></a>00169     <span class="keyword">virtual</span> <span class="keywordtype">bool</span>            resolveParameters       (ProgramSet* programSet);   
<a name="l00170"></a>00170     <span class="keyword">virtual</span> <span class="keywordtype">bool</span>            resolveDependencies     (ProgramSet* programSet);
<a name="l00171"></a>00171     <span class="keyword">virtual</span> <span class="keywordtype">bool</span>            addFunctionInvocations  (ProgramSet* programSet);
<a name="l00172"></a>00172 
<a name="l00176"></a>00176     <span class="keyword">const</span> <span class="keywordtype">char</span>* getAdressingFunctionName(<a class="code" href="classOgre_1_1TextureUnitState.html#a47c5a9f4fc08159b99bdc51103bcf852" title="Texture addressing modes - default is TAM_WRAP.">TextureUnitState::TextureAddressingMode</a> mode);
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 <span class="comment">// Attributes.</span>
<a name="l00180"></a>00180 <span class="keyword">protected</span>:
<a name="l00181"></a>00181     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a> mVSInpTextureTableIndex; <span class="comment">// The index of the information on the texture in the table</span>
<a name="l00182"></a>00182     
<a name="l00183"></a>00183     TextureUnitState::UVWAddressingMode mTextureAddressings[TAS_MAX_TEXTURES]; <span class="comment">// The addressing mode for each texture</span>
<a name="l00184"></a>00184     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a> mVSOutTextureDatas[TAS_MAX_TEXTURES]; <span class="comment">// The position and size of the texture in the atlas </span>
<a name="l00185"></a>00185     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a> mPSInpTextureDatas[TAS_MAX_TEXTURES]; <span class="comment">// The position and size of the texture in the atlas</span>
<a name="l00186"></a>00186     <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a> mPSTextureSizes[TAS_MAX_TEXTURES]; <span class="comment">//A parameter carrying the sizes of the atlas textures</span>
<a name="l00187"></a>00187     <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a> mVSTextureTable[TAS_MAX_TEXTURES]; <span class="comment">// The table containing information on the textures in the atlas</span>
<a name="l00188"></a>00188 
<a name="l00189"></a>00189     <span class="comment">//The position of the texture coordinates containing the index information </span>
<a name="l00190"></a>00190     <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> mAtlasTexcoordPos; 
<a name="l00191"></a>00191     <span class="comment">//The texture atlas table data</span>
<a name="l00192"></a>00192     TextureAtlasTablePtr mAtlasTableDatas[TAS_MAX_TEXTURES];
<a name="l00193"></a>00193     <span class="comment">//For each texture unit in the pass tells if it uses atlas texture</span>
<a name="l00194"></a>00194     <span class="keywordtype">bool</span> mIsAtlasTextureUnits[TAS_MAX_TEXTURES];
<a name="l00195"></a>00195     <span class="comment">//Tells if the data in mAtlasTableData has been uploaded to the corresponding mVSTextureTable parameter</span>
<a name="l00196"></a>00196     <span class="keywordtype">bool</span> mIsTableDataUpdated;
<a name="l00197"></a>00197     <span class="comment">//Tells whether border issue handling uses auto adjust polling position.</span>
<a name="l00198"></a>00198     <span class="keywordtype">bool</span> mAutoAdjustPollPosition;
<a name="l00199"></a>00199 };
<a name="l00200"></a>00200 
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 
<a name="l00207"></a>00207 <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> TextureAtlasSamplerFactory : <span class="keyword">public</span> SubRenderStateFactory, <span class="keyword">public</span> Singleton&lt;TextureAtlasSamplerFactory&gt;
<a name="l00208"></a>00208 {
<a name="l00209"></a>00209 <span class="keyword">public</span>:
<a name="l00210"></a>00210     <span class="keyword">enum</span> IndexPositionMode
<a name="l00211"></a>00211     {
<a name="l00212"></a>00212         ipmRelative,
<a name="l00213"></a>00213         ipmAbsolute
<a name="l00214"></a>00214     };
<a name="l00215"></a>00215 
<a name="l00216"></a>00216     <span class="keyword">struct </span>TextureAtlasAttib
<a name="l00217"></a>00217     {
<a name="l00218"></a>00218         TextureAtlasAttib(IndexPositionMode _posMode = ipmRelative, <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> _posOffset = 1,
<a name="l00219"></a>00219             <span class="keywordtype">bool</span> _autoBorderAdjust = <span class="keyword">true</span>) : positionMode(_posMode), positionOffset(_posOffset),
<a name="l00220"></a>00220              autoBorderAdjust(_autoBorderAdjust) {}
<a name="l00221"></a>00221 
<a name="l00222"></a>00222         IndexPositionMode positionMode;
<a name="l00223"></a>00223         <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> positionOffset;
<a name="l00224"></a>00224         <span class="keywordtype">bool</span> autoBorderAdjust;
<a name="l00225"></a>00225     };
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 <span class="keyword">public</span>:
<a name="l00228"></a>00228 
<a name="l00229"></a>00229     <span class="comment">//TextureAtlasSamplerFactory c_tor</span>
<a name="l00230"></a>00230     TextureAtlasSamplerFactory();
<a name="l00231"></a>00231 
<a name="l00232"></a>00232     <span class="comment">//Singleton implementation</span>
<a name="l00233"></a>00233     <span class="keyword">static</span> TextureAtlasSamplerFactory* getSingletonPtr(<span class="keywordtype">void</span>);
<a name="l00234"></a>00234     <span class="keyword">static</span> TextureAtlasSamplerFactory&amp; getSingleton(<span class="keywordtype">void</span>);
<a name="l00235"></a>00235     
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 
<a name="l00241"></a>00241     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getType() <span class="keyword">const</span>;
<a name="l00242"></a>00242 
<a name="l00246"></a>00246     <span class="keyword">virtual</span> SubRenderState* createInstance(ScriptCompiler* compiler, PropertyAbstractNode* prop, Pass* pass, SGScriptTranslator* translator);
<a name="l00247"></a>00247 
<a name="l00251"></a>00251     <span class="keyword">virtual</span> <span class="keywordtype">void</span> writeInstance(MaterialSerializer* ser, SubRenderState* subRenderState, Pass* srcPass, Pass* dstPass);
<a name="l00252"></a>00252     
<a name="l00271"></a>00271     <span class="keywordtype">bool</span> addTexutreAtlasDefinition( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a>&amp; filename, TextureAtlasTablePtr textureAtlasTable = TextureAtlasTablePtr());
<a name="l00272"></a>00272     <span class="keywordtype">bool</span> addTexutreAtlasDefinition( <a class="code" href="group__Resources.html#ga8a2a961b4205aacff9c01e81e08d7781" title="Shared pointer to allow data streams to be passed around without worrying about deallocation.">DataStreamPtr</a> stream, TextureAtlasTablePtr textureAtlasTable = TextureAtlasTablePtr());
<a name="l00273"></a>00273 
<a name="l00282"></a>00282     <span class="keywordtype">void</span> setTextureAtlasTable(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; textureName, <span class="keyword">const</span> TextureAtlasTablePtr&amp; atlasData, <span class="keywordtype">bool</span> autoBorderAdjust = <span class="keyword">true</span>);
<a name="l00283"></a>00283     
<a name="l00288"></a>00288     <span class="keywordtype">void</span> removeTextureAtlasTable(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; textureName);
<a name="l00289"></a>00289 
<a name="l00293"></a>00293     <span class="keywordtype">void</span> removeAllTextureAtlasTables();
<a name="l00294"></a>00294 
<a name="l00299"></a>00299     <span class="keyword">const</span> TextureAtlasTablePtr&amp; getTextureAtlasTable(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; textureName) <span class="keyword">const</span>;
<a name="l00300"></a>00300 
<a name="l00311"></a>00311     <span class="keywordtype">void</span> setDefaultAtlasingAttributes(IndexPositionMode mode, <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> offset, <span class="keywordtype">bool</span> autoAdjustBorders);
<a name="l00312"></a>00312 
<a name="l00317"></a>00317     <span class="keyword">const</span> TextureAtlasAttib&amp; getDefaultAtlasingAttributes() <span class="keyword">const</span>;
<a name="l00318"></a>00318 
<a name="l00330"></a>00330     <span class="keywordtype">void</span> setMaterialAtlasingAttributes(<a class="code" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Ogre::Material</a>* material, 
<a name="l00331"></a>00331         IndexPositionMode mode, <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> offset, <span class="keywordtype">bool</span> autoAdjustBorders);
<a name="l00332"></a>00332 
<a name="l00333"></a>00333 
<a name="l00339"></a>00339     <span class="keywordtype">bool</span> hasMaterialAtlasingAttributes(<a class="code" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Ogre::Material</a>* material, TextureAtlasAttib* attrib = NULL) <span class="keyword">const</span>;
<a name="l00340"></a>00340     
<a name="l00341"></a>00341 <span class="keyword">protected</span>:
<a name="l00342"></a>00342 
<a name="l00343"></a>00343     
<a name="l00344"></a>00344 
<a name="l00348"></a>00348     <span class="keyword">virtual</span> SubRenderState* createInstanceImpl();
<a name="l00349"></a>00349 
<a name="l00350"></a>00350 <span class="keyword">private</span>:
<a name="l00351"></a>00351 
<a name="l00352"></a>00352     <span class="comment">//Holds a mapping of texture names and the atlas table information associated with them</span>
<a name="l00353"></a>00353     TextureAtlasMap mAtlases;
<a name="l00354"></a>00354 
<a name="l00355"></a>00355     TextureAtlasAttib mDefaultAtlasAttrib;
<a name="l00356"></a>00356 };
<a name="l00357"></a>00357 
<a name="l00358"></a>00358 <a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> <span class="keywordtype">void</span> <a class="code" href="group__General.html#ga6d67d46d838de3b38264f17fb792cddc">operator&lt;&lt;</a>(std::ostream&amp; o, <span class="keyword">const</span> TextureAtlasSamplerFactory::TextureAtlasAttib&amp; tai);
<a name="l00359"></a>00359 
<a name="l00363"></a>00363 }
<a name="l00364"></a>00364 }
<a name="l00365"></a>00365 
<a name="l00366"></a>00366 <span class="preprocessor">#endif</span>
<a name="l00367"></a>00367 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
